Index: src/ellipsoid.cpp
===================================================================
--- src/ellipsoid.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/ellipsoid.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -42,7 +42,5 @@
 
   // 1. translate coordinate system so that ellipsoid center is in origin
-  helper.CopyVector(&x);
-  helper.SubtractVector(&EllipsoidCenter);
-  RefPoint.CopyVector(&helper);
+  RefPoint = helper = x - EllipsoidCenter;
   //Log() << Verbose(4) << "Translated given point is at " << RefPoint << "." << endl;
 
@@ -61,5 +59,5 @@
   Matrix[8] = cos(theta);
   helper.MatrixMultiplication(Matrix);
-  helper.Scale(InverseLength);
+  helper.ScaleAll(InverseLength);
   //Log() << Verbose(4) << "Transformed RefPoint is at " << helper << "." << endl;
 
@@ -72,5 +70,5 @@
   theta = -EllipsoidAngle[1];
   phi = -EllipsoidAngle[2];
-  helper.Scale(EllipsoidLength);
+  helper.ScaleAll(EllipsoidLength);
   Matrix[0] = cos(psi)*cos(phi) - sin(psi)*cos(theta)*sin(phi);
   Matrix[1] = -cos(psi)*sin(phi) - sin(psi)*cos(theta)*cos(phi);
@@ -86,5 +84,5 @@
 
   // 5. determine distance between backtransformed point and x
-  distance = RefPoint.DistanceSquared(&helper);
+  distance = RefPoint.DistanceSquared(helper);
   //Log() << Verbose(4) << "Squared distance between intersection and RefPoint is " << distance << "." << endl;
 
@@ -116,5 +114,5 @@
   // put parameters into suitable ellipsoid form
   for (int i=0;i<3;i++) {
-    Center.x[i] = gsl_vector_get(x, i+0);
+    Center[i] = gsl_vector_get(x, i+0);
     EllipsoidLength[i] = gsl_vector_get(x, i+3);
     EllipsoidAngle[i] = gsl_vector_get(x, i+6);
@@ -146,5 +144,5 @@
 {
   int status = GSL_SUCCESS;
-  Log() << Verbose(2) << "Begin of FitPointSetToEllipsoid " << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Begin of FitPointSetToEllipsoid " << endl);
   if (N >= 3) { // check that enough points are given (9 d.o.f.)
     struct EllipsoidMinimisation par;
@@ -160,5 +158,5 @@
     x = gsl_vector_alloc (9);
     for (int i=0;i<3;i++) {
-      gsl_vector_set (x, i+0, EllipsoidCenter->x[i]);
+      gsl_vector_set (x, i+0, EllipsoidCenter->at(i));
       gsl_vector_set (x, i+3, EllipsoidLength[i]);
       gsl_vector_set (x, i+6, EllipsoidAngle[i]);
@@ -195,9 +193,9 @@
       if (status == GSL_SUCCESS) {
         for (int i=0;i<3;i++) {
-          EllipsoidCenter->x[i] = gsl_vector_get (s->x,i+0);
+          EllipsoidCenter->at(i) = gsl_vector_get (s->x,i+0);
           EllipsoidLength[i] = gsl_vector_get (s->x, i+3);
           EllipsoidAngle[i] = gsl_vector_get (s->x, i+6);
         }
-        Log() << Verbose(4) << setprecision(3) << "Converged fit at: " << *EllipsoidCenter << ", lengths " << EllipsoidLength[0] << ", " << EllipsoidLength[1] << ", " << EllipsoidLength[2] << ", angles " << EllipsoidAngle[0] << ", " << EllipsoidAngle[1] << ", " << EllipsoidAngle[2] << " with summed distance " << s->fval << "." << endl;
+        DoLog(4) && (Log() << Verbose(4) << setprecision(3) << "Converged fit at: " << *EllipsoidCenter << ", lengths " << EllipsoidLength[0] << ", " << EllipsoidLength[1] << ", " << EllipsoidLength[2] << ", angles " << EllipsoidAngle[0] << ", " << EllipsoidAngle[1] << ", " << EllipsoidAngle[2] << " with summed distance " << s->fval << "." << endl);
       }
 
@@ -209,8 +207,8 @@
 
   } else {
-    Log() << Verbose(3) << "Not enough points provided for fit to ellipsoid." << endl;
+    DoLog(3) && (Log() << Verbose(3) << "Not enough points provided for fit to ellipsoid." << endl);
     return false;
   }
-  Log() << Verbose(2) << "End of FitPointSetToEllipsoid" << endl;
+  DoLog(2) && (Log() << Verbose(2) << "End of FitPointSetToEllipsoid" << endl);
   if (status == GSL_SUCCESS)
     return true;
@@ -235,5 +233,5 @@
   int index;
   TesselPoint *Candidate = NULL;
-  Log() << Verbose(2) << "Begin of PickRandomPointSet" << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Begin of PickRandomPointSet" << endl);
 
   // allocate array
@@ -241,5 +239,5 @@
     x = new Vector[PointsToPick];
   } else {
-    eLog() << Verbose(2) << "Given pointer to vector array seems already allocated." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "Given pointer to vector array seems already allocated." << endl);
   }
 
@@ -247,19 +245,19 @@
     for(int i=0;i<NDIM;i++) // pick three random indices
       LC->n[i] = (rand() % LC->N[i]);
-    Log() << Verbose(2) << "INFO: Center cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " ... ";
+    DoLog(2) && (Log() << Verbose(2) << "INFO: Center cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " ... ");
     // get random cell
-    const LinkedNodes *List = LC->GetCurrentCell();
+    const LinkedCell::LinkedNodes *List = LC->GetCurrentCell();
     if (List == NULL) {  // set index to it
       continue;
     }
-    Log() << Verbose(2) << "with No. " << LC->index << "." << endl;
-
-    Log() << Verbose(2) << "LC Intervals:";
+    DoLog(2) && (Log() << Verbose(2) << "with No. " << LC->index << "." << endl);
+
+    DoLog(2) && (Log() << Verbose(2) << "LC Intervals:");
     for (int i=0;i<NDIM;i++) {
       Nlower[i] = ((LC->n[i]-1) >= 0) ? LC->n[i]-1 : 0;
       Nupper[i] = ((LC->n[i]+1) < LC->N[i]) ? LC->n[i]+1 : LC->N[i]-1;
-      Log() << Verbose(0) << " [" << Nlower[i] << "," << Nupper[i] << "] ";
-    }
-    Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << " [" << Nlower[i] << "," << Nupper[i] << "] ");
+    }
+    DoLog(0) && (Log() << Verbose(0) << endl);
 
     // count whether there are sufficient atoms in this cell+neighbors
@@ -268,8 +266,8 @@
       for (LC->n[1] = Nlower[1]; LC->n[1] <= Nupper[1]; LC->n[1]++)
         for (LC->n[2] = Nlower[2]; LC->n[2] <= Nupper[2]; LC->n[2]++) {
-          const LinkedNodes *List = LC->GetCurrentCell();
+          const LinkedCell::LinkedNodes *List = LC->GetCurrentCell();
           PointsLeft += List->size();
         }
-    Log() << Verbose(2) << "There are " << PointsLeft << " atoms in this neighbourhood." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "There are " << PointsLeft << " atoms in this neighbourhood." << endl);
     if (PointsLeft < PointsToPick) {  // ensure that we can pick enough points in its neighbourhood at all.
       continue;
@@ -293,5 +291,5 @@
       for (LC->n[1] = Nlower[1]; LC->n[1] <= Nupper[1]; LC->n[1]++)
         for (LC->n[2] = Nlower[2]; LC->n[2] <= Nupper[2]; LC->n[2]++) {
-          const LinkedNodes *List = LC->GetCurrentCell();
+          const LinkedCell::LinkedNodes *List = LC->GetCurrentCell();
 //          Log() << Verbose(2) << "Current cell is " << LC->n[0] << ", " << LC->n[1] << ", " << LC->n[2] << " with No. " << LC->index << " containing " << List->size() << " points." << endl;
           if (List != NULL) {
@@ -300,9 +298,9 @@
 //            else
 //              Log() << Verbose(2) << "Cell is empty ... " << endl;
-            for (LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
+            for (LinkedCell::LinkedNodes::const_iterator Runner = List->begin(); Runner != List->end(); Runner++) {
               if ((current != PickedAtomNrs.end()) && (*current == index)) {
                 Candidate = (*Runner);
-                Log() << Verbose(2) << "Current picked node is " << **Runner << " with index " << index << "." << endl;
-                x[PointsPicked++].CopyVector(Candidate->node);    // we have one more atom picked
+                DoLog(2) && (Log() << Verbose(2) << "Current picked node is " << **Runner << " with index " << index << "." << endl);
+                x[PointsPicked++] = *Candidate->node;    // we have one more atom picked
                 current++;    // next pre-picked atom
               }
@@ -313,12 +311,12 @@
           }
         }
-    Log() << Verbose(2) << "The following points were picked: " << endl;
+    DoLog(2) && (Log() << Verbose(2) << "The following points were picked: " << endl);
     for (size_t i=0;i<PointsPicked;i++)
-      Log() << Verbose(2) << x[i] << endl;
+      DoLog(2) && (Log() << Verbose(2) << x[i] << endl);
     if (PointsPicked == PointsToPick)  // break out of loop if we have all
       break;
   } while(1);
 
-  Log() << Verbose(2) << "End of PickRandomPointSet" << endl;
+  DoLog(2) && (Log() << Verbose(2) << "End of PickRandomPointSet" << endl);
 };
 
@@ -335,5 +333,5 @@
   double value, threshold;
   PointMap *List = &T->PointsOnBoundary;
-  Log() << Verbose(2) << "Begin of PickRandomPointSet" << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Begin of PickRandomPointSet" << endl);
 
   // allocate array
@@ -341,5 +339,5 @@
     x = new Vector[PointsToPick];
   } else {
-    eLog() << Verbose(2) << "Given pointer to vector array seems already allocated." << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "Given pointer to vector array seems already allocated." << endl);
   }
 
@@ -350,5 +348,5 @@
       //Log() << Verbose(3) << "Current node is " << *Runner->second->node << " with " << value << " ... " << threshold << ": ";
       if (value > threshold) {
-        x[PointsPicked].CopyVector(Runner->second->node->node);
+        x[PointsPicked] = (*Runner->second->node->node);
         PointsPicked++;
         //Log() << Verbose(0) << "IN." << endl;
@@ -358,9 +356,9 @@
       PointsLeft--;
     }
-  Log() << Verbose(2) << "The following points were picked: " << endl;
+  DoLog(2) && (Log() << Verbose(2) << "The following points were picked: " << endl);
   for (size_t i=0;i<PointsPicked;i++)
-    Log() << Verbose(3) << x[i] << endl;
-
-  Log() << Verbose(2) << "End of PickRandomPointSet" << endl;
+    DoLog(3) && (Log() << Verbose(3) << x[i] << endl);
+
+  DoLog(2) && (Log() << Verbose(2) << "End of PickRandomPointSet" << endl);
 };
 
@@ -382,12 +380,12 @@
   double EllipsoidAngle[3];
   double distance, MaxDistance, MinDistance;
-  Log() << Verbose(0) << "Begin of FindDistributionOfEllipsoids" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Begin of FindDistributionOfEllipsoids" << endl);
 
   // construct center of gravity of boundary point set for initial ellipsoid center
   Center.Zero();
   for (PointMap::iterator Runner = T->PointsOnBoundary.begin(); Runner != T->PointsOnBoundary.end(); Runner++)
-    Center.AddVector(Runner->second->node->node);
+    Center += (*Runner->second->node->node);
   Center.Scale(1./T->PointsOnBoundaryCount);
-  Log() << Verbose(1) << "Center is at " << Center << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Center is at " << Center << "." << endl);
 
   // Output header
@@ -397,5 +395,5 @@
   // loop over desired number of parameter sets
   for (;number >0;number--) {
-    Log() << Verbose(1) << "Determining data set " << number << " ... " << endl;
+    DoLog(1) && (Log() << Verbose(1) << "Determining data set " << number << " ... " << endl);
     // pick the point set
     x = NULL;
@@ -405,7 +403,7 @@
     // calculate some sensible starting values for parameter fit
     MaxDistance = 0.;
-    MinDistance = x[0].ScalarProduct(&x[0]);
+    MinDistance = x[0].ScalarProduct(x[0]);
     for (int i=0;i<N;i++) {
-      distance = x[i].ScalarProduct(&x[i]);
+      distance = x[i].ScalarProduct(x[i]);
       if (distance > MaxDistance)
         MaxDistance = distance;
@@ -414,5 +412,5 @@
     }
     //Log() << Verbose(2) << "MinDistance " << MinDistance << ", MaxDistance " << MaxDistance << "." << endl;
-    EllipsoidCenter.CopyVector(&Center);  // use Center of Gravity as initial center of ellipsoid
+    EllipsoidCenter = Center;  // use Center of Gravity as initial center of ellipsoid
     for (int i=0;i<3;i++)
       EllipsoidAngle[i] = 0.;
@@ -423,9 +421,9 @@
     // fit the parameters
     if (FitPointSetToEllipsoid(x, N, &EllipsoidCenter, &EllipsoidLength[0], &EllipsoidAngle[0])) {
-      Log() << Verbose(1) << "Picking succeeded!" << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Picking succeeded!" << endl);
       // output obtained parameter set
       output << number << "\t";
       for (int i=0;i<3;i++)
-        output << setprecision(9) << EllipsoidCenter.x[i] << "\t";
+        output << setprecision(9) << EllipsoidCenter[i] << "\t";
       for (int i=0;i<3;i++)
         output << setprecision(9) << EllipsoidLength[i] << "\t";
@@ -434,5 +432,5 @@
       output << endl;
     } else { // increase N to pick one more
-      Log() << Verbose(1) << "Picking failed!" << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Picking failed!" << endl);
       number++;
     }
@@ -442,4 +440,4 @@
   output.close();
 
-  Log() << Verbose(0) << "End of FindDistributionOfEllipsoids" << endl;
-};
+  DoLog(0) && (Log() << Verbose(0) << "End of FindDistributionOfEllipsoids" << endl);
+};
Index: src/errorlogger.cpp
===================================================================
--- src/errorlogger.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/errorlogger.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,8 +9,7 @@
 #include "errorlogger.hpp"
 #include "verbose.hpp"
+#include "Patterns/Singleton_impl.hpp"
 
 ofstream null("/dev/null");
-
-errorLogger* errorLogger::instance = NULL;
 int errorLogger::verbosity = 2;
 ostream* errorLogger::nix = &null;
@@ -23,5 +22,4 @@
 errorLogger::errorLogger()
 {
-  instance = NULL;
   verbosity = 2;
 };
@@ -34,28 +32,5 @@
 }
 
-/**
- * Returns the singleton errorLogger instance.
- *
- * \return errorLogger instance
- */
-errorLogger* errorLogger::getInstance() {
-  if (instance == NULL) {
-    instance = new errorLogger();
-  }
-
-  return instance;
-}
-
-
-/**
- * Purges the current errorLogger instance.
- */
-void errorLogger::purgeInstance() {
-  if (instance != NULL) {
-    delete instance;
-  }
-
-  instance = NULL;
-}
+CONSTRUCT_SINGLETON(errorLogger)
 
 /**
@@ -81,5 +56,5 @@
   int verbosityLevel = l.verbosity;
   l.nix->clear();
-  if (v.DoOutput(verbosityLevel)) {
+  if (v.DoErrorOutput(verbosityLevel)) {
     switch(v.Verbosity) {
       case 0:
@@ -104,5 +79,5 @@
   int verbosityLevel = l->verbosity;
   l->nix->clear();
-  if (v.DoOutput(verbosityLevel)) {
+  if (v.DoErrorOutput(verbosityLevel)) {
     switch(v.Verbosity) {
       case 0:
@@ -113,7 +88,6 @@
         break;
       case 2:
+      default:
         cerr << "WARNING: ";
-        break;
-      default:
         break;
     }
Index: src/errorlogger.hpp
===================================================================
--- src/errorlogger.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/errorlogger.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -11,15 +11,16 @@
 #include <iostream>
 
+#include "Patterns/Singleton.hpp"
+
 using namespace std;
 
 class Verbose;
 
-class errorLogger {
+class errorLogger : public Singleton<errorLogger>{
+  friend class Singleton<errorLogger>;
 public :
   static ostream *nix;
   static int verbosity;
 
-  static errorLogger* getInstance();
-  static void purgeInstance();
   static bool DoOutput();
   static void setVerbosity(int verbosityLevel);
@@ -31,6 +32,4 @@
   ~errorLogger();
 
-private:
-  static errorLogger* instance;
 };
 
Index: src/graph.cpp
===================================================================
--- src/graph.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/graph.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -85,10 +85,10 @@
   testGraphInsert = Fragment->Leaflet->insert(GraphPair (*Fragment->FragmentSet,pair<int,double>(Fragment->FragmentCounter,Fragment->TEFactor)));  // store fragment number and current factor
   if (testGraphInsert.second) {
-    Log() << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " successfully inserted." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " successfully inserted." << endl);
     Fragment->FragmentCounter++;
   } else {
-    Log() << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl;
+    DoLog(2) && (Log() << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl);
     ((*(testGraphInsert.first)).second).second += Fragment->TEFactor;  // increase the "created" counter
-    Log() << Verbose(2) << "New factor is " << ((*(testGraphInsert.first)).second).second << "." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "New factor is " << ((*(testGraphInsert.first)).second).second << "." << endl);
   }
 };
@@ -115,9 +115,9 @@
     testGraphInsert = graph1.insert(GraphPair ((*runner).first,pair<int,double>((*counter)++,((*runner).second).second)));  // store fragment number and current factor
     if (testGraphInsert.second) {
-      Log() << Verbose(2) << "KeySet " << (*counter)-1 << " successfully inserted." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "KeySet " << (*counter)-1 << " successfully inserted." << endl);
     } else {
-      Log() << Verbose(2) << "KeySet " << (*counter)-1 << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl;
+      DoLog(2) && (Log() << Verbose(2) << "KeySet " << (*counter)-1 << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl);
       ((*(testGraphInsert.first)).second).second += (*runner).second.second;
-      Log() << Verbose(2) << "New factor is " << (*(testGraphInsert.first)).second.second << "." << endl;
+      DoLog(2) && (Log() << Verbose(2) << "New factor is " << (*(testGraphInsert.first)).second.second << "." << endl);
     }
   }
Index: src/gslmatrix.cpp
===================================================================
--- src/gslmatrix.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/gslmatrix.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -10,4 +10,5 @@
 #include "gslmatrix.hpp"
 #include "helpers.hpp"
+#include "Helpers/fast_functions.hpp"
 
 #include <cassert>
@@ -178,5 +179,5 @@
         gsl_matrix_set(dest, j,i, gsl_matrix_get(matrix, i,j) );
       }
-    delete(matrix);
+    gsl_matrix_free(matrix);
     matrix = dest;
     flip(rows, columns);
Index: src/gslvector.cpp
===================================================================
--- src/gslvector.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/gslvector.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -6,5 +6,9 @@
  */
 
+#include <cassert>
+#include <cmath>
+
 #include "gslvector.hpp"
+#include "defs.hpp"
 
 /** Constructor of class GSLVector.
@@ -27,4 +31,14 @@
 };
 
+/** Copy constructor of class GSLVector.
+ * Allocates GSL structures and copies components from \a *src.
+ * \param *src source vector
+ */
+GSLVector::GSLVector(const GSLVector & src) : dimension(src.dimension)
+{
+  vector = gsl_vector_alloc(dimension);
+  gsl_vector_memcpy (vector, src.vector);
+};
+
 /** Destructor of class GSLVector.
  * Frees GSL structures
@@ -33,5 +47,4 @@
 {
   gsl_vector_free(vector);
-  dimension = 0;
 };
 
@@ -52,5 +65,5 @@
  * \return  m-th element of vector
  */
-double GSLVector::Get(size_t m)
+double GSLVector::Get(size_t m) const
 {
   return gsl_vector_get (vector, m);
@@ -72,5 +85,5 @@
  * \return pointer to \a m-th element
  */
-double *GSLVector::Pointer(size_t m)
+double *GSLVector::Pointer(size_t m) const
 {
   return gsl_vector_ptr (vector, m);
@@ -82,7 +95,18 @@
  * \return const pointer to \a m-th element
  */
-const double *GSLVector::const_Pointer(size_t m)
+const double *GSLVector::const_Pointer(size_t m) const
 {
   return gsl_vector_const_ptr (vector, m);
+};
+
+/** Returns the dimension of the vector.
+ * \return dimension of vector
+ */
+#ifdef HAVE_INLINE
+inline
+#endif
+size_t GSLVector::GetDimension() const
+{
+  return dimension;
 };
 
@@ -128,2 +152,142 @@
   return gsl_vector_reverse (vector);
 };
+
+
+/* ========================== Operators =============================== */
+/** Compares GSLVector \a to GSLVector \a b component-wise.
+ * \param a base GSLVector
+ * \param b GSLVector components to add
+ * \return a == b
+ */
+bool operator==(const GSLVector& a, const GSLVector& b)
+{
+  bool status = true;
+  assert(a.GetDimension() == b.GetDimension() && "Dimenions of GSLVectors to compare differ");
+  for (size_t i=0;i<a.GetDimension();i++)
+    status = status && (fabs(a.Get(i) - b.Get(i)) < MYEPSILON);
+  return status;
+};
+
+/** Sums GSLVector \a to this lhs component-wise.
+ * \param a base GSLVector
+ * \param b GSLVector components to add
+ * \return lhs + a
+ */
+const GSLVector& operator+=(GSLVector& a, const GSLVector& b)
+{
+  assert(a.GetDimension() == b.GetDimension() && "Dimenions of GSLVectors to compare differ");
+  for (size_t i=0;i<a.GetDimension();i++)
+    a.Set(i,a.Get(i)+b.Get(i));
+  return a;
+};
+
+/** Subtracts GSLVector \a from this lhs component-wise.
+ * \param a base GSLVector
+ * \param b GSLVector components to add
+ * \return lhs - a
+ */
+const GSLVector& operator-=(GSLVector& a, const GSLVector& b)
+{
+  assert(a.GetDimension() == b.GetDimension() && "Dimenions of GSLVectors to compare differ");
+  for (size_t i=0;i<a.GetDimension();i++)
+    a.Set(i,a.Get(i)-b.Get(i));
+  return a;
+};
+
+/** factor each component of \a a times a double \a m.
+ * \param a base GSLVector
+ * \param m factor
+ * \return lhs.Get(i) * m
+ */
+const GSLVector& operator*=(GSLVector& a, const double m)
+{
+  for (size_t i=0;i<a.GetDimension();i++)
+    a.Set(i,a.Get(i)*m);
+  return a;
+};
+
+/** Sums two GSLVectors \a  and \b component-wise.
+ * \param a first GSLVector
+ * \param b second GSLVector
+ * \return a + b
+ */
+GSLVector const operator+(const GSLVector& a, const GSLVector& b)
+{
+  GSLVector x(a);
+  for (size_t i=0;i<a.GetDimension();i++)
+    x.Set(i,a.Get(i)+b.Get(i));
+  return x;
+};
+
+/** Subtracts GSLVector \a from \b component-wise.
+ * \param a first GSLVector
+ * \param b second GSLVector
+ * \return a - b
+ */
+GSLVector const operator-(const GSLVector& a, const GSLVector& b)
+{
+  assert(a.GetDimension() == b.GetDimension() && "Dimenions of GSLVectors to compare differ");
+  GSLVector x(a);
+  for (size_t i=0;i<a.GetDimension();i++)
+    x.Set(i,a.Get(i)-b.Get(i));
+  return x;
+};
+
+/** Factors given GSLVector \a a times \a m.
+ * \param a GSLVector
+ * \param m factor
+ * \return m * a
+ */
+GSLVector const operator*(const GSLVector& a, const double m)
+{
+  GSLVector x(a);
+  for (size_t i=0;i<a.GetDimension();i++)
+    x.Set(i,a.Get(i)*m);
+  return x;
+};
+
+/** Factors given GSLVector \a a times \a m.
+ * \param m factor
+ * \param a GSLVector
+ * \return m * a
+ */
+GSLVector const operator*(const double m, const GSLVector& a )
+{
+  GSLVector x(a);
+  for (size_t i=0;i<a.GetDimension();i++)
+    x.Set(i,a.Get(i)*m);
+  return x;
+};
+
+ostream& operator<<(ostream& ost, const GSLVector& m)
+{
+  ost << "(";
+  for (size_t i=0;i<m.GetDimension();i++) {
+    ost << m.Get(i);
+    if (i != 2)
+      ost << ",";
+  }
+  ost << ")";
+  return ost;
+};
+
+/* ====================== Checking State ============================ */
+/** Checks whether vector has all components zero.
+ * @return true - vector is zero, false - vector is not
+ */
+bool GSLVector::IsZero() const
+{
+  return (fabs(Get(0))+fabs(Get(1))+fabs(Get(2)) < MYEPSILON);
+};
+
+/** Checks whether vector has length of 1.
+ * @return true - vector is normalized, false - vector is not
+ */
+bool GSLVector::IsOne() const
+{
+  double NormValue = 0.;
+  for (size_t i=dimension;--i;)
+    NormValue += Get(i)*Get(i);
+  return (fabs(NormValue - 1.) < MYEPSILON);
+};
+
Index: src/gslvector.hpp
===================================================================
--- src/gslvector.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/gslvector.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -18,4 +18,5 @@
 #endif
 
+#include <iostream>
 #include <gsl/gsl_vector.h>
 
@@ -32,12 +33,14 @@
   GSLVector(size_t m);
   GSLVector(const GSLVector * const src);
+  GSLVector(const GSLVector & src);
   ~GSLVector();
 
   // Accessing
   void SetFromDoubleArray(double *x);
-  double Get(size_t m);
+  double Get(size_t m) const;
   void Set(size_t m, double x);
-  double *Pointer(size_t m);
-  const double *const_Pointer(size_t m);
+  double *Pointer(size_t m) const;
+  const double *const_Pointer(size_t m) const;
+  size_t GetDimension() const;
 
   // Initializing
@@ -50,9 +53,24 @@
   int Reverse();
 
+  // checking state
+  bool IsZero() const;
+  bool IsOne() const;
+
 private:
   gsl_vector *vector;
 
-  size_t dimension;
+  const size_t dimension;
 };
+
+ostream & operator << (ostream& ost, const GSLVector &m);
+bool operator==(const GSLVector& a, const GSLVector& b);
+const GSLVector& operator+=(GSLVector& a, const GSLVector& b);
+const GSLVector& operator-=(GSLVector& a, const GSLVector& b);
+const GSLVector& operator*=(GSLVector& a, const double m);
+GSLVector const operator*(const GSLVector& a, const double m);
+GSLVector const operator*(const double m, const GSLVector& a);
+GSLVector const operator+(const GSLVector& a, const GSLVector& b);
+GSLVector const operator-(const GSLVector& a, const GSLVector& b);
+
 
 
Index: src/helpers.cpp
===================================================================
--- src/helpers.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/helpers.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -6,4 +6,5 @@
 
 #include "helpers.hpp"
+#include "Helpers/fast_functions.hpp"
 #include "log.hpp"
 #include "memoryusageobserver.hpp"
@@ -19,5 +20,5 @@
   double test = 0.1439851348959832147598734598273456723948652983045928346598365;
   do {
-    Log() << Verbose(0) << text;
+    DoLog(0) && (Log() << Verbose(0) << text);
     cin >> test;
   } while (test == 0.1439851348959832147598734598273456723948652983045928346598365);
@@ -49,18 +50,4 @@
   while (*b < lower_bound)
     *b += step;
-};
-
-/** Returns the power of \a n with respect to \a base.
- * \param base basis
- * \param n power
- * \return \f$base^n\f$
- */
-int pot(int base, int n)
-{
-  int res = 1;
-  int j;
-  for (j=n;j--;)
-    res *= base;
-  return res;
 };
 
@@ -175,33 +162,5 @@
 };
 
-/** hard-coded determinant of a 3x3 matrix.
- * \param a[9] matrix
- * \return \f$det(a)\f$
- */
-double RDET3(const double a[NDIM*NDIM])
-{
-  return ((a)[0]*(a)[4]*(a)[8] + (a)[3]*(a)[7]*(a)[2] + (a)[6]*(a)[1]*(a)[5] - (a)[2]*(a)[4]*(a)[6] - (a)[5]*(a)[7]*(a)[0] - (a)[8]*(a)[1]*(a)[3]);
-};
-
-/** hard-coded determinant of a 2x2 matrix.
- * \param a[4] matrix
- * \return \f$det(a)\f$
- */
-double RDET2(const double a[4])
-{
-  return ((a[0])*(a[3])-(a[1])*(a[2]));
-};
-
-/** hard-coded determinant of a 2x2 matrix.
- * \param a0 (0,0) entry of matrix
- * \param a1 (0,1) entry of matrix
- * \param a2 (1,0) entry of matrix
- * \param a3 (1,1) entry of matrix
- * \return \f$det(a)\f$
- */
-double RDET2(const double a0, const double a1, const double a2, const double a3)
-{
-  return ((a0)*(a3)-(a1)*(a2));
-};
+
 
 /** Comparison function for GSL heapsort on distances in two molecules.
Index: src/helpers.hpp
===================================================================
--- src/helpers.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/helpers.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -24,9 +24,4 @@
 /********************************************** definitions *********************************/
 
-// some algebraic matrix stuff
-double RDET3(const double a[NDIM*NDIM]);
-double RDET2(const double a[4]);
-double RDET2(const double a0, const double a1, const double a2, const double a3);
-
 /********************************************** helpful functions *********************************/
 
@@ -53,5 +48,4 @@
 bool check_bounds(double *x, double *cell_size);
 void bound(double *b, double lower_bound, double upper_bound);
-int pot(int base, int n);
 int CountLinesinFile(ifstream &InputFile);
 char *FixedDigitNumber(const int FragmentNumber, const int digits);
@@ -64,15 +58,4 @@
 /********************************************** helpful template functions *********************************/
 
-/** Flips two values.
- * \param x first value
- * \param y second value
- */
-template <typename T> void flip(T &x, T &y)
-{
-  T tmp;
-  tmp = x;
-  x = y;
-  y = tmp;
-};
 
 /** returns greater of the two values.
@@ -114,5 +97,5 @@
 
   if (LookupTable != NULL) {
-    Log() << Verbose(0) << "Pointer for Lookup table is not NULL! Aborting ..." <<endl;
+    DoLog(0) && (Log() << Verbose(0) << "Pointer for Lookup table is not NULL! Aborting ..." <<endl);
     return false;
   }
@@ -127,5 +110,5 @@
   }
   if (count <= 0) {
-    Log() << Verbose(0) << "Count of lookup list is 0 or less." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Count of lookup list is 0 or less." << endl);
     return false;
   }
@@ -134,5 +117,5 @@
   LookupTable = Calloc<T*>(count, "CreateFatherLookupTable - **LookupTable");
   if (LookupTable == NULL) {
-    eLog() << Verbose(0) << "LookupTable memory allocation failed!" << endl;
+    DoeLog(0) && (eLog()<< Verbose(0) << "LookupTable memory allocation failed!" << endl);
     performCriticalExit();
     status = false;
@@ -146,5 +129,5 @@
         LookupTable[AtomNo] = Walker;
       } else {
-        Log() << Verbose(0) << "Walker " << *Walker << " exceeded range of nuclear ids [0, " << count << ")." << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Walker " << *Walker << " exceeded range of nuclear ids [0, " << count << ")." << endl);
         status = false;
         break;
@@ -189,3 +172,27 @@
 #define PLURAL_S(v) (((v)==1)?"":"s")
 
+// this is to allow different modes of access for
+// maps and sets
+template<typename Res,typename T>
+struct _take{
+  Res get(T value) const;
+};
+
+// if we have a set,vector etc we can directly access the result
+template<typename Res>
+struct _take<Res,Res>{
+  static inline Res get(Res value){
+    return value;
+  }
+};
+
+// if we have a map we have to access the second part of
+// the pair
+template<typename Res,typename T1>
+struct _take<Res,std::pair<T1,Res> >{
+  static inline Res get(std::pair<T1,Res> value){
+    return value.second;
+  }
+};
+
 #endif /*HELPERS_HPP_*/
Index: src/info.cpp
===================================================================
--- src/info.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/info.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -21,5 +21,5 @@
   verbosity++;
   FunctionName = msg;
-  Log() << Verbose(0) << "Begin of " << FunctionName << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Begin of " << FunctionName << endl);
 };
 
@@ -28,5 +28,5 @@
  */
 Info::~Info() {
-  Log() << Verbose(0) << "End of " << FunctionName << endl;
+  DoLog(0) && (Log() << Verbose(0) << "End of " << FunctionName << endl);
   verbosity--;
 }
